package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMApply;
import cn.ibizlab.eam.core.eam_core.filter.EMApplySearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMApplyMapper extends BaseMapper<EMApply>{

    Page<EMApply> searchDefault(IPage page, @Param("srf") EMApplySearchContext context, @Param("ew") Wrapper<EMApply> wrapper) ;
    @Override
    EMApply selectById(Serializable id);
    @Override
    int insert(EMApply entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMApply entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMApply> selectByEquipid(@Param("emequipid") Serializable emequipid) ;

    List<EMApply> selectByObjid(@Param("emobjectid") Serializable emobjectid) ;

    List<EMApply> selectByRfoacid(@Param("emrfoacid") Serializable emrfoacid) ;

    List<EMApply> selectByRfocaid(@Param("emrfocaid") Serializable emrfocaid) ;

    List<EMApply> selectByRfodeid(@Param("emrfodeid") Serializable emrfodeid) ;

    List<EMApply> selectByRfomoid(@Param("emrfomoid") Serializable emrfomoid) ;

    List<EMApply> selectByRserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMApply> selectByRdeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMApply> selectByCloseempid(@Param("pfempid") Serializable pfempid) ;

    List<EMApply> selectByMpersonid(@Param("pfempid") Serializable pfempid) ;

    List<EMApply> selectByRempid(@Param("pfempid") Serializable pfempid) ;

    List<EMApply> selectByRteamid(@Param("pfteamid") Serializable pfteamid) ;

}
